%global irrxml_version 1.2
%global irrlicht_version 1.7.3
%global master_release 4

Name:		irrlicht
Summary: 	A high performance realtime 3D engine
Version:	%{irrlicht_version}
Release:	%{master_release}%{?dist}
License:	zlib
Group:		System Environment/Libraries
Source0:	http://downloads.sourceforge.net/irrlicht/%{name}-%{irrlicht_version}.zip
# Until 1.8 comes out, we're making an SVN snapshot subpackage. (3629 is what supertuxcart wants)
# svn export -r 3629 https://irrlicht.svn.sourceforge.net/svnroot/irrlicht/trunk/ irrlicht18-svn3629
# cd irrlicht18-svn3629
# rm -rf source/Irrlicht/jpeglib source/Irrlicht/zlib source/Irrlicht/libpng source/Irrlicht/aesGladman
# cd ..
# tar cf irrlicht18-svn3629.tar.bz2 irrlicht18-svn3629
Source1:	irrlicht18-svn3629.tar.bz2
# Various fixes, optflags, system libraries/headers
# http://irrlicht.sourceforge.net/phpBB2/viewtopic.php?t=24076&highlight=
Patch0:		irrlicht-1.7.3-optflags.patch
# Get the code compiling
Patch1:		irrlicht-1.5.1-glext.patch
# Use system libaesgm
Patch2:		irrlicht-1.7.1-libaesgm.patch
# Use improved fastatof from assimp
Patch3:		irrlicht-1.7.2-fastatof-improvements-typefixes.patch
# Make libIrrXML.so
Patch4:		irrlicht-1.7.3-irrXML-shared-library.patch
# Use png15
Patch5:		irrlicht-1.7.2-png15.patch
# 1.8 patches
Patch6:		irrlicht18-optflags.patch
Patch7:		irrlicht18-glext.patch
Patch8:		irrlicht18-libaesgm.patch
Patch9:		irrlicht18-fastatof-improvements-typefixes.patch
Patch10:	irrlicht18-irrXML-shared-library.patch
# Remove "-SVN" from Version
Patch11:	irrlicht18-noSVN.patch

URL:		http://irrlicht.sourceforge.net/
BuildRequires:	libXxf86vm-devel, mesa-libGL-devel, mesa-libGLU-devel
BuildRequires:	libjpeg-devel, zlib-devel, libaesgm-devel
BuildRequires:	libpng-devel, bzip2-devel

%description
The Irrlicht Engine is an open source high performance realtime 3D engine 
written and usable in C++ and also available for .NET languages. It is 
completely cross-platform, using D3D, OpenGL and its own software renderer, 
and has all of the state-of-the-art features which can be found in 
commercial 3d engines.

%package devel
Summary:	Development headers and libraries for irrlicht
Requires:	%{name}%{?_isa} = %{irrlicht_version}-%{release}
Requires:	mesa-libGL-devel, mesa-libGLU-devel, libXxf86vm-devel
Requires:	libjpeg-devel, zlib-devel, libpng-devel
Requires:	irrXML-devel%{?_isa} = %{irrxml_version}
Group:		Development/Libraries

%description devel
Development headers and libraries for irrlicht.

%package -n irrXML
Summary:	Simple and fast XML parser for C++
Group:		System Environment/Libraries
Version:	%{irrxml_version}

%description -n irrXML
irrXML is a simple and fast open source xml parser for C++.

%package -n irrXML-devel
Summary:	Development headers and libraries for irrXML
Version:	%{irrxml_version}
Requires:	irrXML%{?_isa} = %{irrxml_version}-%{release}
Group:		Development/Libraries

%description -n irrXML-devel
Development headers and libraries for irrXML.

%package -n irrlicht18
Summary:	A high performance realtime 3D engine
Version:	1.8
Release:	0.%{master_release}.svn3629%{?dist}

%description -n irrlicht18
The Irrlicht Engine is an open source high performance realtime 3D engine
written and usable in C++ and also available for .NET languages. It is
completely cross-platform, using D3D, OpenGL and its own software renderer,
and has all of the state-of-the-art features which can be found in
commercial 3d engines. This is an SVN checkout of what will eventually become
Irrlicht 1.8.

%package -n irrlicht18-devel
Summary:	Development headers and libraries for Irrlicht18
Version:	1.8
Release:	0.%{master_release}.svn3629%{?dist}
Requires:	irrlicht18%{?_isa} = 1.8-0.%{master_release}.svn3629%{?dist}
Requires:	mesa-libGL-devel, mesa-libGLU-devel, libXxf86vm-devel
Requires:       libjpeg-devel, zlib-devel, libpng-devel
Requires:       irrXML18-devel%{?_isa} = 1.8-0.%{master_release}.svn3629%{?dist}

%description -n irrlicht18-devel
Development headers and libraries for Irrlicht18

%package -n irrXML18
Summary:        Simple and fast XML parser for C++
Version:        1.8
Release:	0.%{master_release}.svn3629%{?dist}

%description -n irrXML18
irrXML is a simple and fast open source xml parser for C++.
This is the corresponding irrXML for Irrlicht18.

%package -n irrXML18-devel
Summary:        Development headers and libraries for irrXML18
Version:        1.8
Release:	0.%{master_release}.svn3629%{?dist}
Requires:       irrXML18%{?_isa} = 1.8-0.%{master_release}.svn3629%{?dist}

%description -n irrXML18-devel
Development headers and libraries for irrXML18.

%prep
%setup -q
%patch0 -p1 -b .optflags
%patch1 -p1 -b .glext
%patch2 -p1 -b .libaesgm
%patch3 -p1 -b .fastatof
%patch4 -p1 -b .irrXML
%patch5 -p1 -b .png15

sed -i 's/\r//' readme.txt
iconv -o readme.txt.iso88591 -f iso88591 -t utf8 readme.txt
mv readme.txt.iso88591 readme.txt
# We don't use any of this. Deleting it so the debuginfo doesn't pick it up.
rm -rf source/Irrlicht/jpeglib source/Irrlicht/zlib source/Irrlicht/libpng source/Irrlicht/aesGladman

for i in include/*.h doc/upgrade-guide.txt source/Irrlicht/*.cpp source/Irrlicht/*.h; do
  	sed -i 's/\r//' $i
	chmod -x $i
	touch -r changes.txt $i
done

# unpack the svn tree separately
tar xf %{SOURCE1}
%patch6 -p0 -b .optflags18
%patch7 -p0 -b .glext18
%patch8 -p0 -b .libaesgm18
%patch9 -p0 -b .fastatof18
%patch10 -p0 -b .irrXML18
%patch11 -p0 -b .noSVN
pushd irrlicht18-svn3629
sed -i 's/\r//' readme.txt
iconv -o readme.txt.iso88591 -f iso88591 -t utf8 readme.txt
mv readme.txt.iso88591 readme.txt
popd

%build
cd source/Irrlicht
make %{?_smp_mflags} sharedlib

pushd ../../irrlicht18-svn3629/source/Irrlicht
make %{?_smp_mflags} sharedlib
popd


%install
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_includedir}/%{name}
make -C source/Irrlicht INSTALL_DIR=%{buildroot}%{_libdir} install 
cp -a include/*.h %{buildroot}%{_includedir}/%{name}/
pushd %{buildroot}%{_libdir}
ln -s libIrrlicht.so.%{irrlicht_version} libIrrlicht.so.1
ln -s libIrrXML.so.%{irrlicht_version} libIrrXML.so.1
popd

mkdir -p %{buildroot}%{_includedir}/%{name}18
pushd irrlicht18-svn3629
make -C source/Irrlicht INSTALL_DIR=%{buildroot}%{_libdir} install
cp -a include/*.h %{buildroot}%{_includedir}/%{name}18/
popd
pushd %{buildroot}%{_libdir}
ln -s libIrrlicht18.so.1.8.0 libIrrlicht18.so.1
ln -s libIrrXML18.so.1.8.0 libIrrXML18.so.1
popd

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post -n irrXML -p /sbin/ldconfig
%postun -n irrXML -p /sbin/ldconfig

%post -n irrlicht18 -p /sbin/ldconfig
%postun -n irrlicht18 -p /sbin/ldconfig

%post -n irrXML18 -p /sbin/ldconfig
%postun -n irrXML18 -p /sbin/ldconfig

%files
%doc readme.txt
%{_libdir}/libIrrlicht.so.*

%files devel
%doc doc/upgrade-guide.txt
%{_includedir}/%{name}/
%exclude %{_includedir}/%{name}/fast_atof.h
%exclude %{_includedir}/%{name}/heapsort.h
%exclude %{_includedir}/%{name}/irrArray.h
%exclude %{_includedir}/%{name}/irrString.h
%exclude %{_includedir}/%{name}/irrTypes.h
%exclude %{_includedir}/%{name}/irrXML.h
%{_libdir}/libIrrlicht.so

%files -n irrlicht18
%doc irrlicht18-svn3629/readme.txt
%{_libdir}/libIrrlicht18.so.*

%files -n irrlicht18-devel
%doc irrlicht18-svn3629/doc/upgrade-guide.txt
%{_includedir}/%{name}18/
%exclude %{_includedir}/%{name}18/fast_atof.h
%exclude %{_includedir}/%{name}18/heapsort.h
%exclude %{_includedir}/%{name}18/irrArray.h
%exclude %{_includedir}/%{name}18/irrString.h
%exclude %{_includedir}/%{name}18/irrTypes.h
%exclude %{_includedir}/%{name}18/irrXML.h
%{_libdir}/libIrrlicht18.so

%files -n irrXML18
%doc irrlicht18-svn3629/readme.txt
%{_libdir}/libIrrXML18.so.*

%files -n irrXML18-devel
%dir %{_includedir}/%{name}18/
%{_includedir}/%{name}18/fast_atof.h
%{_includedir}/%{name}18/heapsort.h
%{_includedir}/%{name}18/irrArray.h
%{_includedir}/%{name}18/irrString.h
%{_includedir}/%{name}18/irrTypes.h
%{_includedir}/%{name}18/irrXML.h
%{_libdir}/libIrrXML18.so

%files -n irrXML
%doc readme.txt
%{_libdir}/libIrrXML.so.*

%files -n irrXML-devel
%dir %{_includedir}/%{name}/
%{_includedir}/%{name}/fast_atof.h
%{_includedir}/%{name}/heapsort.h
%{_includedir}/%{name}/irrArray.h
%{_includedir}/%{name}/irrString.h
%{_includedir}/%{name}/irrTypes.h
%{_includedir}/%{name}/irrXML.h
%{_libdir}/libIrrXML.so

%changelog
* Thu Aug 23 2012 Tom Callaway <spot@fedoraproject.org> - 1.7.3-4
- add missing %%{dist} tags.

* Thu Aug 23 2012 Tom Callaway <spot@fedoraproject.org> - 1.7.3-3
- add Irrlicht18 subpackages for supertuxkart (they'll be killed off when 1.8 is final/stable)

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon Jun 25 2012 Tom Callaway <spot@fedoraproject.org> - 1.7.3-1
- update to 1.7.3

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.2-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Dec 06 2011 Tom Callaway <spot@fedoraproject.org> - 1.7.2-10
- fix irrlicht to use libpng-config for cflags/libs
- patches for support for libpng15

* Tue Dec 06 2011 Adam Jackson <ajax@redhat.com> - 1.7.2-9
- Rebuild for new libpng

* Wed Aug  3 2011 Tom Callaway <spot@fedoraproject.org> - 1.7.2-8
- cleanup spec
- use correct version when performing symlink

* Tue Mar 22 2011 Tom Callaway <spot@fedoraproject.org> - 1.7.2-7
- fix soname version in link (bz699767)

* Tue Mar 22 2011 Tom Callaway <spot@fedoraproject.org> - 1.7.2-6
- rework shared library patch to ignore crufty ld flags
- rework fast_atof patch to use new naming, more portable typing
- do not package unnecessary patch history files

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 15 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.2-4
- add post/postun scripts for irrXML

* Wed Dec 15 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.2-3
- fix versioning on irrXML-devel

* Wed Dec 15 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.2-2
- make subpackages for irrXML
- use assimp patch for performance improvement in IrrXML

* Wed Nov 17 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.2-1
- update to 1.7.2

* Mon May 24 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.1-2
- rebuild against fixed libaesgm

* Thu Feb 18 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 1.7.1-1
- update to 1.7.1

* Thu Jan 14 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 1.6.1-1
- update to 1.6.1

* Wed Sep 30 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 1.6-1
- update to 1.6

* Wed Aug 19 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 1.5.1-1
- update to 1.5.1

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Jan 10 2009 Tom "spot" Callaway <tcallawa@redhat.com> 1.5-2
- fix libpng calls so we can use system libpng (thanks to tom lane)
- fix license tag

* Thu Jan 8 2009 Tom "spot" Callaway <tcallawa@redhat.com> 1.5-1
- build against system libpng
- update to 1.5 final

* Thu Dec 4 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.5-0.2.beta
- fix optflags patch so that ldconfig isn't called during make install

* Wed Dec 3 2008 Tom "spot" Callaway <tcallawa@redhat.com> 1.5-0.1.beta
- Initial package for Fedora
